apt-get(8)

NAME
apt-get - APT package handling utility -- command-line interface

SYNOPSIS
apt-get [options] [command] [package ...]

DESCRIPTION

apt-get is the command-line tool for handling packages, and may be considered the user's "back-end" to apt(8).

command is one of:

o   update

o   upgrade

o   dselect-upgrade

o   dist-upgrade

o   install package1 [package2] [...]

o   remove package1 [package2] [...]

o   source package1 [package2] [...]

o   check

o   clean

o   autoclean

Unless the -h, or --help option is given one of the above commands must be present.

update
    update is used to resynchronize the package overview files from their sources. The overviews of available packages are fetched from the location(s) specified in /etc/apt/sources.list. For example, when using a Debian archive, this command retrieves and scans the Packages.gz files, so that information about new and updated packages is available. An update should always be performed before an upgrade dist-upgrade. Please be aware that the overall progress meter will be incorrect as the size of the package files cannot be known in advance.

upgrade
    upgrade is used to install the newest versions of all packages currently installed on the system from the sources enumerated in /etc/apt/sources.list. Packages currently installed with new versions available are retrieved and upgraded; under no circumstances are currently installed packages removed, or packages not already installed retrieved and installed. New versions of currently installed packages that cannot be upgraded without changing the install status of another package will be left at their current version. An update must be performed first so that apt-get knows that new versions of packages are available.

dselect-upgrade
    dselect-upgrade is used in conjunction with the traditional Debian GNU/Linux packaging front-end, dselect (8). dselect-upgrade follows the changes made by dselect to the Status field of available packages, and performs the actions necessary to realize that state (for instance, the removal of old and the installation of new packages).

dist-upgrade
    dist-upgrade,in addition to performing the function of upgrade, also intelligently handles changing dependencies with new versions of packages; apt-get has a "smart" conflict resolution system, and it will attempt to upgrade the most important packages at the expense of less important ones if necessary. The /etc/apt/sources.list file contains a list of locations from which to retrieve desired package files.

install
    install is followed by one or more packages desired for installation. Each package is a package name, not a fully qualified filename (for instance, in a Debian GNU/Linux system, ldso would be the argument provided, not ldso_1.9.6-2.deb). All packages required by the package(s) specified for installation will also be retrieved and installed. The /etc/apt/sources.list file is used to locate the desired packages. If a hyphen is appended to the package name (with no intervening space), the identified package will be removed if it is installed. This latter feature may be used to override decisions made by apt-get's conflict resolution system.

    If no package matches the given expression and the expression contains one of '.', '?' or '*' then it is assumed to be a POSIX regex and it is applied to all package names in the database. Any matches are then installed (or removed). Note that matching is done by substring so 'lo*' matches 'how-lo' and 'lowest'. If this is undesired prefix with a '^' character.

remove
    remove is identical to install except that packages are removed instead of installed. If a plus sign is appended to the package name (with no intervening space), the identified package will be installed.

source
    source causes apt-get to fetch source packages. APT will examine the available packages to decide which source package to fetch. It will then find and download into the current directory the newest available version of that source package. Source packages are tracked separately from binary packages via deb-src type lines in the /etc/apt/sources.list file. This probably will mean that you will not get the same source as the package you have installed or as you could install. If the --compile options is specified then the package will be compiled to a binary .deb using dpkg-buildpackage, if --download-only is specified then the source package will not be unpacked.

    Note that source packages are not tracked like binary packages, they exist only in the current directory and are similar to downloading source tar balls.

check
    check is a diagnostic tool; it updates the package cache and checks for broken packages.

clean
    clean clears out the local repository of retrieved package files. It removes everything but the lock file from /var/cache/apt/archives/ and /var/cache/apt/archives/partial/. When APT is used as a dselect(8) method, clean is run automatically. Those who do not use dselect will likely want to run apt-get clean from time to time to free up disk space.

autoclean
    Like clean, autoclean clears out the local repository of retrieved package files. The difference is that it only removes package files that can no longer be downloaded, and are largely useless. This allows a cache to be maintained over a long period without it growing out of control.

OPTIONS
All command line options may be set using the configuration file, the descriptions indicate the configuration option to set. For boolean options you can override the config file by using something like -f-, --no-f, -f=no or several other variations.

-d, --download-only
    Download only; package files are only retrieved, not unpacked or installed. Configuration Item: APT::Get::Download-Only.

-f, --fix-broken
    Fix; attempt to correct a system with broken dependencies in place. This option, when used with install/remove, can omit any packages to permit APT to deduce a likely soltion. Any Package that are specified must completly correct the problem. The option is sometimes necessary when running APT for the first time; APT itself does not allow broken package dependencies to exist on a system. It is possible that a system's dependency structure can be so corrupt as to require manual intervention (which usually means using dselect or dpkg --remove to eliminate some of the offending packages). Use of this option together with -m may produce an error in some situations. Configuration Item: APT::Get::Fix-Broken.

-h, --help
    Help; display a helpful usage message and exits.

-v, --version
    Show the program version.

-m, --ignore-missing, --fix-missing
    Ignore missing packages; If packages cannot be retrieved or fail the integrity check after retrieval (corrupted package files), hold back those packages and handle the result. Use of this option together with -f may produce an error in some situations. If a package is selected for installation (particularly if it is mentioned on the command line) and it could not be downloaded then it will be silently held back. Configuration Item: APT::Get::ignore-missing.

--no-download
    Disables downloading of packages. This is best used with --ignore-missing to force APT to use only the .debs it has already downloaded. Configuration Item: APT::Get::No-Download.

-q, --quiet
    Quiet; produces output suitable for logging, omitting progress indicators. More q's will produce more quiet up to a maximum of 2. You can also use -q=# to set the quiet level, overriding the configuration file. Note that quiet level 2 implies -y, you should never use -qq without a no-action modifier such as -d, --print-uris or -s as APT may decided to do something you did not expect. Configuration Item: quiet

-s, --simulate, --just-print, --dry-run, --recon, --no-act
    No action; perform a simulation of events that would occur but do not actually change the system. Configuration Item: APT::Get::Simulate.

    Simulate prints out a series of lines each one representing a dpkg operation, Configure (Conf), Remove (Remv), Unpack (Inst). Square brackets indicate broken packages with and empty set of square brackets meaning breaks that are of no consequence (rare).

-y, --yes, --assume-yes
    Automatic yes to prompts; assume "yes" as answer to all prompts and run non-interactively. If an undesirable situation, such as changing a held package or removing an essential package occurs then apt-get will abort. Configuration Item: APT::Get::Assume-Yes.

-u, --show-upgraded
    Show upgraded packages; Print out a list of all packages that are to be upgraded. Configuration Item: APT::Get::Show-Upgraded.

-b, --compile, --build
    Compile source packages after downloading them. Configuration Item: APT::Get::Compile.

--ignore-hold
    Ignore package Holds; This causes apt-get to ignore a hold placed on a package. This may be useful in conjunction with dist-upgrade to override a large number of undesired holds. Configuration Item: APT::Ignore-Hold.

--no-upgrade
    Do not upgrade packages; When used in conjunction with install no-upgrade will prevent packages listed from being upgraded if they are already installed. Configuration Item: APT::Get::no-upgrade.

--force-yes
    Force yes; This is a dangerous option that will cause apt to continue without prompting if it is doing something potentially harmful. It should not be used except in very special situations. Using force-yes can potentially destroy your system! Configuration Item: APT::Get::force-yes.

--print-uris
    Instead of fetching the files to install their URIs are printed. Each URI will have the path, the destination file name, the size and the expected md5 hash. Note that the file name to write to will not always match the file name on the remote site! This also works with the source command. Configuration Item: APT::Get::Print-URIs.

--purge
    Use purge instead of remove for anything that would be removed. Configuration Item: APT::Get::Purge.

--reinstall
    Re-Install packages that are already installed and at the newest version.

--list-cleanup
    This option defaults to on, use --no-list-cleanup to turn it off. When on apt-get will automatically manage the contents of /var/state/apt/lists to ensure that obsolete files are erased. The only reason to turn it off is if you frequently change your source list. Configuration Item: APT::Get::List-Cleanup

--trivial-only
    Only perform operations are 'trivial'. Logically this can be considered related to --assume-yes, where --assume-yes will answer yes to any prompt, --trivial-only will answer no. Configuration Item: APT::Get::Trivial-Only

--no-remove
    If any packages are to be removed apt-get immediately aborts without prompting. Configuration Item: APT::Get::No-Remove

--diff-only, --tar-only
    Download only the diff or tar file of a source archive. Configuration Item: APT::Get::Diff-Only

-c, --config-file
    Configuration File; Specify a configuration file to use. apt-get will read the default configuration file and then this configuration file. See apt.conf(5) for syntax information.

-o, --option
    Set a Configuration Option; This will set an arbitrary configuration option. The syntax is

    -o Foo::Bar=bar

FILES

o   /etc/apt/sources.list locations to fetch packages from

o   /var/cache/apt/archives/ storage area for retrieved package files

o   /var/cache/apt/archives/partial/ storage area for package files in transit

o   /var/state/apt/lists/ storage area for state information for each package resource specified in the source list

o   /var/state/apt/lists/partial/ storage area for state information in transit

SEE ALSO
apt-cache(8), dpkg(8), dselect(8), sources.list(5), apt.conf(5), The APT Users Guide in /usr/doc/apt/

DIAGNOSTICS
apt-get returns zero on normal operation, decimal 100 on error.

BUGS
See http://bugs.debian.org/apt. If you wish to report a bug in apt-get, please see /usr/doc/debian/bug-reporting.txt or the bug(1) command.

AUTHOR
apt-get was written by the APT team <apt@packages.debian.org>.